<?php
/*
Plugin Name: Get Blogger Post IDs
Version: 2.0
Plugin URI: http://justinsomnia.org/2007/11/importing-haloscan-comments-into-wordpress-23-from-blogger/
Description: Get your old Blogger postIDs for use in importing your old Haloscan comments
Author: Justin Watt
Author URI: http://justinsomnia.org/

2.0
Significant updates by Mike Conover http://www.sidtheduck.com/

1.0
initial version

LICENSE

wp-get-blogger-post-ids.php
Copyright (C) 2007 Justin Watt
justincwatt@gmail.com
http://justinsomnia.org/

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

function manage_get_blogger_post_ids() {
  // Add a new menu under Manage:
  add_management_page('Get Blogger postIDs', 'Get Blogger postIDs', 10, __FILE__, 'get_blogger_post_ids');
}

function get_blogger_post_ids() 
{
  global $wpdb;

  echo "<div class='wrap'>";
  echo "<h2>Get Blogger postIDs</h2>";


  if ($_POST['function'] == 'get_ids') {

    $domain = str_replace(array("http://", '/'), "", trim($_POST['domain']));
    $path   = str_replace("/",                   "", trim($_POST['path']));
    $numposts = intval($_POST['numposts']);
    empty($_POST['post_count']) ? $postcount = 0 : $postcount = intval($_POST['post_count']);
    $done = 0;

    if ($path != '') {
      $path = "/" . $path;
    }


    $meta_records = $wpdb->get_results("select * from $wpdb->postmeta where meta_key = 'blogger_permalink'");
    if (count($meta_records) == 0) {
      echo "<p>No WordPress posts were found with blogger permalinks. Have you run the Blogger importer yet?</p>";

    } else {

      echo "<p><strong>Progress:</strong></p>";

      $totalposts = count($meta_records);
      if ($totalposts <= ($numposts+$postcount) || $numposts==0){
         $totalcount = $totalposts;
      }else{
         $totalcount = $numposts+$postcount;
      }
      
      for($i=$postcount;$i<$totalcount;$i++) {
        $post_match = 0;
        $x = $i+1;
        echo $x.': Importing id for ' . $meta_records[$i]->meta_value . ': ';
    
        $fp = fsockopen($domain, 80, $errno, $errstr, 30);
        
        if (!$fp) {
          echo "$errstr ($errno)<br />\n";
        
        } else {
          $out = "GET ".$path.$meta_records[$i]->meta_value." HTTP/1.1\r\n";
          $out .= "Host: ".$domain."\r\n";
          $out .= "Connection: Close\r\n\r\n";
          
          fwrite($fp, $out);

          while (!feof($fp)) {
            $line = fgets($fp);
            if (strpos($line, 'postID=') !== false) {
              if (preg_match("/postID=(\d+)/", $line, $matches)) {
                echo "found " . $matches[1] . "<br />\n";
                add_post_meta($meta_records[$i]->post_id, 'blogger_id', $matches[1], true);
                $post_match = 1;
                break;
              }
            }
          }
          if ($post_match!==1){
            echo "<strong>postID not found for this permalink.  Please check your blogger template for this individual post (permalink).</strong><br />\n";
          }
          fclose($fp);
        }
        if ($i==($totalposts-1)){
          $done = 1;
        }
      }
      if ($done===1){
         echo "<br/><br/>\n";
         echo "<h2><strong>Done!</strong></h2>\n";
         echo "Now you can run the <a href=\"import-haloscan.php\">import-haloscan.php</a> (<em>make sure you've uploaded your export.xml file[s] first!</em>)";
      }else{
         echo "<p>You are <strong>not</strong> done, there are more postIDs to be imported.</p>";
         echo "<form action='' method='post'>\n";
         echo "<input type='hidden' name='domain' value='".$domain."' />\n";
         echo "<input type='hidden' name='path' value='".$path."' />\n";
         echo "<input type='hidden' name='function' value='get_ids' />\n";
         echo "<input type='hidden' name='post_count' value='".$i."' />\n";
         echo "<input type='hidden' name='numposts' value='".$numposts."' />\n";
         echo "<input type='submit' value='Continue' />\n";
         echo "</form>\n";
      }
    }
  
  } else { 

    ?>
    
    <form action='' method='post'>
    Blogger blog domain: <input type="text" name="domain" /> (e.g. <code>www.myblogrules.com</code> or <code>myblogrules.blogspot.com</code> - leave out the http:// or trailing slashes)<br />
    Optional permalink path: <input type="text" name="path" /> (e.g. <code>weblog</code> - the part after your domain, but before the /2007/10/my-blog-rules.html part) <br />
    Number of posts per import cycle:
    <select name="numposts">
      <option value="5">5</option>
		<option value="10">10</option>
		<option value="25">25</option>
		<option value="50">50</option>
		<option value="75">75</option>
		<option value="100">100</option>
      <option value="0" selected>All at once</option>
	 </select>
    *Change this only if you encounter problems due to bandwidth or server speed or you encounter problems with <a target="_blank" href="http://www.php.net/manual/en/ref.info.php#ini.max-execution-time">max_execution_time</a> setting.<br/>
    (<em>your server's max_execution_time is currently set to <strong><?php print ini_get('max_execution_time');?> seconds</strong></em>)<br/>
    <input type="hidden" name='function' value='get_ids' />
    <input type='submit' value='Get Blogger postIDs' />
    </form>

    <?php
      
  }

  echo "</div>";
}


add_action('admin_menu', 'manage_get_blogger_post_ids');
?>
